10 REM      =====  "BUTS", son of "IFS"  =====

       Oscar Garcia, Forest Research Institute. March 1982

11 DEFINT I-N
12 REM - Clear screen code for diferent BASIC versions -

  (GW-BASIC/BASICA, AMSTRAD PCW8256, MS-BASIC + ANSI)
13 IF CSRLIN THEN CL$=CHR$(12): KEY OFF

   ELSE IF VERSION(0) THEN CL$=CHR$(27)+"H"+CHR$(27)+"J"

   ELSE CL$=CHR$(27)+"[2J"
15 PRINT CL$
18 PRINT TAB(18)"FOREST MANAGEMENT SIMULATION":

   PRINT TAB(18)"============================": PRINT :GOSUB 9900
20 READ N,M,W,Y0,TE,R,BP,E 'crops,ages,class width,start year,

         periods,interest rate,base price,elasticity
22 YB=Y0
30 DATA 2,7,5,1982,6,10,10,-.7
50 REM -- INITIALISE --
60 DIM A(N,M),Y(N,M),CA(N,M),CV(N,M),V(TE),P(TE)
70 DR=(1+R/100)^(-W/2)

:  RP=DR^2

:  Z=0
80 FOR I=1 TO N

:    FOR J=1 TO M

:      READ A(I,J),Y(I,J)

:      A(I,0)=A(I,0)+A(I,J)

:      IF DR*Y(I,J)>Y(I,J-1) THEN Y(I,0)=J
82   NEXT J

:    A(0,0)=A(0,0)+A(I,0)

:    BQ=BQ+A(I,0)*Y(I,Y(I,0))/M

:  NEXT I
90 REM -- AREA AND YIELD DATA
100 DATA 158422,0,138324,.153,68972,.306,32231,.463,21736,.663,9987,.864,32413,1.064,105615,0,103725,.069,53927,.139,31216,.210,13230,.301,11985,.393,66355,.484
102 PRINT
110 REM --- MAIN ROUTINE ---
120 GOSUB 1000 'DISPLAY STATUS
130 IF T>=TE THEN 310 'FINISH
140 PRINT

:   PRINT"OPTIONS: (1) Display yield information"

:   PRINT"         (2) Display production and price trends"

:   PRINT"         (3) Try cut"

:   PRINT"         (4) Display instructions"

:   PRINT"                      PRESS NUMBER KEY . . .";
145 K$=INKEY$
150 K$=INKEY$:IF K$="" THEN 150 ELSE

    IF K$="1" THEN GOSUB 2000 ELSE IF K$="2" THEN GOSUB 5000

    ELSE IF K$="3" THEN 160 ELSE IF K$<>"4" THEN 150

    ELSE GOSUB 9900: GOTO 120
151 PRINT: PRINT,"PRESS ANY KEY TO CONTINUE . . .";:K$=INKEY$
152 IF INKEY$="" THEN 152 ELSE 120
160 PRINT:PRINT

:   FOR I=1 TO N

:     PRINT "Cutting crop type"I". Volume or area? ";

:     K$=INKEY$
170   K$=INKEY$:IF K$="" THEN 170 ELSE

        IF K$="V" OR K$="v" THEN PRINT "Volume":GOTO 210

          ELSE IF K$<>"A" AND K$<>"a" THEN 170 ELSE PRINT "Area"
175   INPUT "Area to be cut (ha)";X

:     IF X<0 THEN PRINT "HUH?": GOTO 175
180   CA(I,0)=0: CV(I,0)=0

:     FOR J=M TO 1 STEP -1

:       IF A(I,J)<X THEN CA(I,J)=A(I,J) ELSE CA(I,J)=X
190     X=X-CA(I,J): CV(I,J)=Y(I,J)*CA(I,J)

:       CA(I,0)=CA(I,0)+CA(I,J): CV(I,0)=CV(I,0)+CV(I,J)

:     NEXT J

:     IF X THEN PRINT

       "FOREST EXHAUSTED. ONLY"CA(I,0)" HA CUT."
200   GOTO 230
210   INPUT "Volume to be cut (thou.cu.m.)";X

:     IF X<0 THEN PRINT "HUH?":GOTO 210 ELSE

      CA(I,0)=0: CV(I,0)=0

:     FOR J=M TO 1 STEP -1
212     IF X THEN IF Y(I,J)*A(I,J)<X THEN CA(I,J)=A(I,J)

                   ELSE CA(I,J)=X/Y(I,J)

        ELSE CA(I,J)=0
220     CV(I,J)=Y(I,J)*CA(I,J): X=X-CV(I,J)

:       CA(I,0)=CA(I,0)+CA(I,J): CV(I,0)=CV(I,0)+CV(I,J)

:     NEXT J

:     IF X THEN PRINT

       "FOREST EXHAUSTED. ONLY"CV(I,0)" THOU.CU.M. CUT."
230   GOSUB 3000

:     IF EF THEN RETURN ELSE

    NEXT I
240 PRINT: CA(0,0)=0: CV(0,0)=0

:   FOR I=1 TO N

:     CA(0,0)=CA(0,0)+CA(I,0): CV(0,0)=CV(0,0)+CV(I,0)

:   NEXT I

:   IF CV(0,0) THEN PR=BP*(CV(0,0)/BQ)^E ELSE PR=BP
242 IF EF THEN RETURN
250 GOSUB 4000: PRINT

:   PRINT"OPTIONS: (1) Go ahead"

:   PRINT"         (2) Try again"

:   PRINT"   PRESS NUMBER KEY . . .": K$=INKEY$
260 K$=INKEY$: IF K$="" THEN 260 ELSE IF K$="2" THEN 120

    ELSE IF K$<>"1" THEN 260
270 REM --- UPDATE AND ADVANCE ---
280 PRINT;

:   T=T+1

:   FOR I=1 TO N

:     A(I,M)=A(I,M)+A(I,M-1)-CA(I,M)-CA(I,M-1)

:     FOR J=M-2 TO 1 STEP -1

:       A(I,J+1)=A(I,J)-CA(I,J)

:     NEXT J

:     A(I,1)=CA(I,0)

:   NEXT I
290 P(T)=PR: V(T)=CV(0,0)

:   Z=Z+DR*PR*CV(0,0)/1000

:   DR=DR*RP

:   Y0=Y0+W

:   GOTO 120
300 REM --- EVALUATE END STATUS ---
310 PRINT "End of planning period. Liquidating forest..."

:   EF=1

:   FOR I=1 TO N

:     X=A(I,0)

:     GOSUB 180

:   NEXT I

:   GOSUB 240

:   Z=Z+DR*BP*CV(0,0)/1000
320 GOSUB 5000: PRINT

:   PRINT "Total present worth: ";Z;"million dollars"
400 PRINT:PRINT: PRINT "Our best is 1649 million.":PRINT:PRINT,"PRESS ANY KEY  . . .";:K$=INKEY$
410 IF INKEY$="" THEN 410 ELSE 10000
1000 REM --- DISPLAY STATUS ---
1010 PRINT CL$

:    PRINT "YEAR"Y0,"PRESENT WORTH:"Z"MILLION DOLLARS"
1020 I$=" ##!##  #######  ####### "

:    H$="  AGE     AREA    VOLUME "

:    U$="(years)   (ha)  (thou.m3)"

:    S$=STRING$(14," ")
1030 PRINT TAB(8)"CROP TYPE 1" TAB(47) "CROP TYPE 2"

:    PRINT H$;S$;H$: PRINT U$;S$;U$
1038 FOR J=1 TO M

:      K2=W*J: K1=K2-W+1: IF J=M THEN K2=99
1040   FOR I=1 TO 2

:        PRINT USING I$;K1,"-",K2,A(I,J),A(I,J)*Y(I,J);

:        IF I<2 THEN PRINT S$; ELSE PRINT
1050 NEXT I,J

:    RETURN
2000 REM --- DISPLAY YIELDS ---
2010 PRINT CL$: PRINT TAB(5) "CROP TYPE 1" TAB(37) "CROP TYPE 2"
2020 FOR I=1 TO 2: PRINT "  AGE        YIELD              ";

:    NEXT I: PRINT

:    FOR I=1 TO 2: PRINT "(years)     (m3/ha)             ";

:    NEXT I: PRINT
2028 FOR J=1 TO M

:      K2=W*J: K1=K2-W+1: IF J=M THEN K2=99
2030   FOR I=1 TO 2

:        PRINT USING " ##!##       ####               ";

          K1,"-",K2,1000*Y(I,J);

:    NEXT I: PRINT: NEXT J

:    MS=64*(J+2)
2040 RETURN
3000 REM --- DISPLAY CROP I ---
3010 RETURN ' NOT INPLEMENTED
4000 REM --- CUT REPORT ---
4010 PRINT CL$

:    PRINT "Area cut:";CA(0,0);"hectares"

:    PRINT "Volume cut:";CV(0,0);"thousand cubic metres"

:    PRINT:PRINT "Price:";:PRINT USING "$$###.##";PR;

:    PRINT " per cubic metre"
4020 PRINT:PRINT "Total income this period:";PR*CV(0,0)/1000;" million dollars"
4030 RETURN
5000 REM --- VOLUME AND PRICE TRENDS ---
5010 PRINT CL$: IF T=0 THEN PRINT "NONE YET": RETURN ELSE

     PRINT "       VOLUME (THOU. CU.M.)";

:    PRINT TAB(40)"       PRICE ($/CU.M.)"
5020 FOR I=1 TO T

:      IF V(I)>VM THEN VM=V(I)
5030   IF P(I)>PM THEN PM=P(I)
5040 NEXT I
5050 I$="####!#### "
5060 FOR I=1 TO T

:      K1=YB+W*I-W: K2=K1+W-1

:      PRINT USING I$;K1,"-",K2;
5062   X=14*V(I)/VM+.5: PRINT STRING$(X,219);

:      IF X-INT(X)>.5 THEN PRINT CHR$(221);
5064  PRINT USING "#######";V(I);
5070   PRINT TAB(40) USING I$;K1,"-",K2;
5072   X=14*P(I)/PM: PRINT STRING$(X,219);

:      IF X-INT(X)>.5 THEN PRINT CHR$(221);
5074   PRINT USING "###.##";P(I)

:    NEXT I
5080 RETURN
9900 REM ---- INSTRUCTIONS ----
9910 PRINT"     This is a highly simplified simulation of forest"

:    PRINT"management at the regional or national level. You have two"
9915 PRINT"types of forest (crop types) which grow at different rates"

:    PRINT"and produce a hamogeneous product. Starting with a given"
9920 PRINT"age distribution in 1982, you have to decide how much area"

:    PRINT"or volume to cut from each of the crop types in each five"
9925 PRINT"year period until the year 2012. The specified area or volume"

:    PRINT"is cut from the oldest age classes available. The price"
9930 PRINT"or value per cubic metre of wood depends of how much"

:    PRINT"volume you cut in each period: a low production causes high"
9935 PRINT"prices and vice-versa. The value of the timber produced in"

:    PRINT"each period is adjusted according to the interest rate to an"
9940 PRINT"equivalent value for 1982 (present worth, or PW), and"

:    PRINT"accumulated. You must try to obtain the maximum total PW"

:    PRINT"possible."
9950 PRINT: PRINT ,"PRESS ANY KEY . . .";:K$=INKEY$
9960 IF INKEY$="" THEN 9960 ELSE RETURN
10000 REM ---- FINAL TEXT ----
10005 PRINT CL$
10010 PRINT"     Reality is obviously much more complex than this"

:     PRINT"demonstration shows. There are usually dozens or hundreds of"
10015 PRINT"crop types, and multiple products (pulpwood, sawlogs of"

:     PRINT"different sizes and qualities, logs for plywood production,"
10020 PRINT"etc.). Yields, product mix and quality can be altered through"

:     PRINT"thinning and pruning (see the FOREST TENDING SIMULATION)."
10025 PRINT"Demand varies with population and export markets growth."

:     PRINT"factors such as employment, availability of labor and":K$=CHR$(34)
10030 PRINT"capital, existing industries, etc., must be considered."

:     PRINT"     Computerised systems such as "K$"IFS"K$" and "K$"CPLAN"K$" are":     PRINT"currently available for helping the forest managers with long"
10032 PRINT"term planning. The development and improvement of such systems"
10040 PRINT"is one of the activities of the Forest Mensuration group."
10050 PRINT: PRINT,"PRESS ANY KEY . . .";:K$=INKEY$
10060 IF INKEY$="" THEN 10060 ELSE RUN
f the Forest Mensuration group."
10050 PRINT: PRINT,"PRESS ANY KEY . . .";:K$=INKEY$
10