9  REM      =====  "BUTS", son of "IFS"  =====
   REM   Oscar Garcia, Forest Research Institute. March 1982
10 REM  -  Traduccin espaola: Diciembre 1997
11 DEFINT I-N
12 REM - Clear screen code for diferent BASIC versions -
   REM (GW-BASIC/BASICA, AMSTRAD PCW8256, MS-BASIC + ANSI)
13 IF CSRLIN THEN CL$ = CHR$(12)': KEY OFF ELSE IF VERSION(0) THEN CL$ = CHR$(27) + "H" + CHR$(27) + "J" ELSE CL$ = CHR$(27) + "[2J"
15 PRINT CL$
18 PRINT TAB(16); "SIMULACION DE MANEJO DE BOSQUES":
   PRINT TAB(16); "===============================": PRINT : GOSUB 9900
20 READ N, M, W, Y0, TE, R, BP, E'crops,ages,class width,start year,periods,interest rate,base price,elasticity
22 YB = Y0
30 DATA 2,7,5,1997,6,10,10,-.7
50 REM -- INITIALISE --
60 DIM A(N, M), y(N, M), CA(N, M), CV(N, M), V(TE), P(TE)
70 DR = (1 + R / 100) ^ (-W / 2)
:  RP = DR ^ 2
:  Z = 0
80 FOR I = 1 TO N
:    FOR J = 1 TO M
:      READ A(I, J), y(I, J)
:      A(I, 0) = A(I, 0) + A(I, J)
:      IF DR * y(I, J) > y(I, J - 1) THEN y(I, 0) = J
82   NEXT J
:    A(0, 0) = A(0, 0) + A(I, 0)
:    BQ = BQ + A(I, 0) * y(I, y(I, 0)) / M
:  NEXT I
90 REM -- AREA AND YIELD DATA
100 DATA 158422,0,138324,.153,68972,.306,32231,.463,21736,.663,9987,.864,32413,1.064,105615,0,103725,.069,53927,.139,31216,.210,13230,.301,11985,.393,66355,.484
102 PRINT
110 REM --- MAIN ROUTINE ---
120 GOSUB 1000 'DISPLAY STATUS
130 IF T >= TE THEN 310'FINISH
140 PRINT
:   PRINT "OPCIONES: (1) Mostrar informacin de rendimientos"
:   PRINT "          (2) Mostrar tendencias de precios y produccin"
:   PRINT "          (3) Tratar corta"
:   PRINT "          (4) Mostrar instrucciones"
:   PRINT "                      NUMERO? . . .";
145 K$ = INKEY$
150 K$ = INKEY$: IF K$ = "" THEN 150 ELSE
    IF K$ = "1" THEN GOSUB 2000 ELSE IF K$ = "2" THEN GOSUB 5000 ELSE IF K$ = "3" THEN 160 ELSE IF K$ <> "4" THEN 150 ELSE GOSUB 9900: GOTO 120
151 PRINT : PRINT , "CUALQUIER TECLA PARA CONTINUAR . . ."; : K$ = INKEY$
152 IF INKEY$ = "" THEN 152 ELSE 120
160 PRINT : PRINT
:   FOR I = 1 TO N
:     PRINT "Cortando tipo"; I; ". Volumen o Area? ";
:     K$ = INKEY$
170   K$ = INKEY$: IF K$ = "" THEN 170 ELSE
        IF K$ = "V" OR K$ = "v" THEN PRINT "Volumen": GOTO 210 ELSE IF K$ <> "A" AND K$ <> "a" THEN 170 ELSE PRINT "Area"
175   INPUT "Area a cortar (ha)"; X
:     IF X < 0 THEN PRINT "EH?": GOTO 175
180   CA(I, 0) = 0: CV(I, 0) = 0
:     FOR J = M TO 1 STEP -1
:       IF A(I, J) < X THEN CA(I, J) = A(I, J) ELSE CA(I, J) = X
190     X = X - CA(I, J): CV(I, J) = y(I, J) * CA(I, J)
:       CA(I, 0) = CA(I, 0) + CA(I, J): CV(I, 0) = CV(I, 0) + CV(I, J)
:     NEXT J
:     IF X THEN PRINT "BOSQUE AGOTADO. SOLO"; CA(I, 0); " HA CORTADAS."
200   GOTO 230
210   INPUT "Volumen a cortar (miles de m3)"; X
:     IF X < 0 THEN PRINT "EH?": GOTO 210 ELSE
        CA(I, 0) = 0: CV(I, 0) = 0
:     FOR J = M TO 1 STEP -1
212     IF X THEN IF y(I, J) * A(I, J) < X THEN CA(I, J) = A(I, J) ELSE CA(I, J) = X / y(I, J) ELSE CA(I, J) = 0
220     CV(I, J) = y(I, J) * CA(I, J): X = X - CV(I, J)
:       CA(I, 0) = CA(I, 0) + CA(I, J): CV(I, 0) = CV(I, 0) + CV(I, J)
:     NEXT J
:     IF X THEN PRINT "BOSQUE AGOTADO. SOLO"; CV(I, 0); " MILES DE M3 CORTADOS."
230   GOSUB 3000
:     IF EF THEN RETURN ELSE
    NEXT I
240 PRINT : CA(0, 0) = 0: CV(0, 0) = 0
:   FOR I = 1 TO N
:     CA(0, 0) = CA(0, 0) + CA(I, 0): CV(0, 0) = CV(0, 0) + CV(I, 0)
:   NEXT I
:   IF CV(0, 0) THEN PR = BP * (CV(0, 0) / BQ) ^ E ELSE PR = BP
242 IF EF THEN RETURN
250 GOSUB 4000: PRINT
:   PRINT "OPCIONES: (1) Hacerlo"

:   PRINT "          (2) Tratar otra vez"

:   PRINT "   NUMERO? . . .": K$ = INKEY$
260 K$ = INKEY$: IF K$ = "" THEN 260 ELSE IF K$ = "2" THEN 120 ELSE IF K$ <> "1" THEN 260
270 REM --- UPDATE AND ADVANCE ---
280 PRINT ;
:   T = T + 1
:   FOR I = 1 TO N
:     A(I, M) = A(I, M) + A(I, M - 1) - CA(I, M) - CA(I, M - 1)
:     FOR J = M - 2 TO 1 STEP -1
:       A(I, J + 1) = A(I, J) - CA(I, J)
:     NEXT J
:     A(I, 1) = CA(I, 0)
:   NEXT I
290 P(T) = PR: V(T) = CV(0, 0)
:   Z = Z + DR * PR * CV(0, 0) / 1000
:   DR = DR * RP
:   Y0 = Y0 + W
:   GOTO 120
300 REM --- EVALUATE END STATUS ---
310 PRINT "Fin del perodo de planificacin. Liquidando el bosque..."

:   EF = 1
:   FOR I = 1 TO N
:     X = A(I, 0)
:     GOSUB 180
:   NEXT I
:   GOSUB 240
:   Z = Z + DR * BP * CV(0, 0) / 1000
320 GOSUB 5000: PRINT
:   PRINT "Valor total actualizado: "; Z; "millones de dlares"
400 PRINT : PRINT : PRINT "Nuestro record es 1649 millones.": PRINT : PRINT , "CUALQUIER TECLA  . . ."; : K$ = INKEY$
410 IF INKEY$ = "" THEN 410 ELSE 10000
1000 REM --- DISPLAY STATUS ---
1010 PRINT CL$
:    PRINT "AO"; Y0, "VALOR ACTUALIZADO:"; Z; "MILLONES DE DOLARES"
1020 I$ = " ##!##  #######  ####### "
:    H$ = " EDAD     AREA    VOLUMEN "

:    U$ = "(aos)    (ha)  (miles m3)"

:    S$ = STRING$(14, " ")
1030 PRINT TAB(10); "TIPO 1"; TAB(49); "TIPO 2"

:    PRINT H$; S$; H$: PRINT U$; S$; U$
1038 FOR J = 1 TO M
:      K2 = W * J: K1 = K2 - W + 1: IF J = M THEN K2 = 99
1040   FOR I = 1 TO 2
:        PRINT USING I$; K1, "-", K2, A(I, J), A(I, J) * y(I, J);
:        IF I < 2 THEN PRINT S$;  ELSE PRINT
1050 NEXT I, J
:    RETURN
2000 REM --- DISPLAY YIELDS ---
2010 PRINT CL$: PRINT TAB(7); "TIPO 1"; TAB(39); "TIPO 2"
2020 FOR I = 1 TO 2: PRINT " EDAD     RENDIMIENTO           ";

:    NEXT I: PRINT
:    FOR I = 1 TO 2: PRINT "(aos)      (m3/ha)             ";

:    NEXT I: PRINT
2028 FOR J = 1 TO M
:      K2 = W * J: K1 = K2 - W + 1: IF J = M THEN K2 = 99
2030   FOR I = 1 TO 2
:        PRINT USING " ##!##       ####               "; K1, "-", K2, 1000 * y(I, J);
:    NEXT I: PRINT : NEXT J
:    MS = 64 * (J + 2)
2040 RETURN
3000 REM --- DISPLAY CROP I ---
3010 RETURN ' NOT INPLEMENTED
4000 REM --- CUT REPORT ---
4010 PRINT CL$
:    PRINT "Area cortada:"; CA(0, 0); "hectreas"

:    PRINT "Volumen cortado:"; CV(0, 0); "miles de metros cbicos"

:    PRINT : PRINT "Precio:"; : PRINT USING "$$###.##"; PR;

:    PRINT " por metro cbico"
4020 PRINT : PRINT "Ingreso total en este perodo:"; PR * CV(0, 0) / 1000; " millones de dlares"
4030 RETURN
5000 REM --- VOLUME AND PRICE TRENDS ---
5010 PRINT CL$: IF T = 0 THEN PRINT "NADA AUN": RETURN ELSE
     PRINT "       VOLUMEN (1000 M3)";
:    PRINT TAB(40); "       PRECIO ($/M3)"
5020 VM = 0: PM = 0: FOR I = 1 TO T
:      IF V(I) > VM THEN VM = V(I)
5030   IF P(I) > PM THEN PM = P(I)
5040 NEXT I
5050 I$ = "####!#### "
5060 FOR I = 1 TO T
:      K1 = YB + W * I - W: K2 = K1 + W - 1
:      PRINT USING I$; K1, "-", K2;
5062   X = 14 * V(I) / VM: PRINT STRING$(X, 219);
:      IF X - INT(X) > .5 THEN PRINT CHR$(221);
5064  PRINT USING "#######"; V(I);
5070   PRINT TAB(40); : PRINT USING I$; K1, "-", K2;
5072   X = 14 * P(I) / PM: PRINT STRING$(X, 219);
:      IF X - INT(X) > .5 THEN PRINT CHR$(221);
5075   PRINT USING "###.##"; P(I)
:    NEXT I
5080 RETURN
9900 REM ---- INSTRUCTIONS ----
9910 PRINT "    Esta es una simulacin altamente simplificada de manejo"
:    PRINT "de bosques al nivel regional o nacional.  Tienes dos tipos de"
9915 PRINT "monte con distintas tasas de crecimiento y que producen un"
:    PRINT "producto homogneo.  Empezando con una distribucin de edades"
9920 PRINT "dada en 1997, tienes que decidir cunta rea o volumen cortar"
:    PRINT "de cada tipo en cada perodo de cinco aos hasta el ao 2027."
9925 PRINT "El rea o volumen especificados se cortan empezando por las"
:    PRINT "edades mayores.  El precio o valor por metro cbico de madera"
9930 PRINT "depende de cunto volumen cortes en cada perodo:  una"
:    PRINT "produccin baja produce precios altos y vice-versa.  El valor"
9935 PRINT "de la madera producida en cada perodo se ajusta de acuerdo a"
:    PRINT "la tasa de inters a un valor equivalente para 1997 (valor"
9940 PRINT "actualizado neto, o VAN), y se acumula.  Debes tratar de"
:    PRINT "obtener el mximo total posible para el VAN."
9950 PRINT : PRINT , "PRESIONA UNA TECLA . . ."; : K$ = INKEY$
9960 IF INKEY$ = "" THEN 9960 ELSE RETURN
10000 REM ---- FINAL TEXT ----
10005 PRINT CL$
10010 PRINT "    La realidad es obviamente mucho ms compleja que lo que"
:     PRINT "ensea esta demostracin.  Hay generalmente docenas o cientos"
10015 PRINT "de tipos de monte, y productos mltiples (madera para pasta,"
:     PRINT "trozos aserrables de distintos tamaos y calidades, trozos"
10020 PRINT "para contrachapados, etc.).  Los rendimientos, mezcla de"
:     PRINT "productos y calidad pueden alterarse a travs de claras y"
10025 PRINT "podas (ver la SIMULACION DE MANEJO DE RODALES).  La demanda"
:     PRINT "vara con el crecimiento de la poblacin y de los mercados."
10030 PRINT "Hay que considerar factores como el empleo, disponibilidad de"
:     PRINT "mano de obra y de capital, industrias existentes, etc.": K$ = CHR$(34)
10032 PRINT "   	Actualmente se dispone de sistemas computacionales como"
10040 PRINT K$; "IFS"; K$; " y "; K$; "CPLAN"; K$; " para asistir a los gestores forestales"
:     PRINT "con la planificacin a largo plazo.  El desarrollo y mejora"
10042 PRINT "de tales sistemas es una de las actividades del grupo de"
:     PRINT "Mensura Forestal.": PRINT
10044 PRINT "(Demostracin para 'Open Days' del Forest Research Institute,"
:     PRINT "Nueva Zelandia.  O. Garca, 1982)"
10050 PRINT : PRINT , "PRESIONA UNA TECLA . . ."; : K$ = INKEY$
10060 IF INKEY$ = "" THEN 10060 ELSE RUN

